#include "..\C-Engine\CHeader.hpp"
#include "Goomba.hpp"
#include "Koopa.hpp"

class GUI: public Script
{
    public:
    void Start();
    void Update();
    void AddCoins(int v);

    int coins;
};

void GUI::Start()
{
    coins = 0;
}

void GUI::Update()
{
    ML_rectangle(-1,-1,128,7,1,ML_BLACK,ML_WHITE);
    PrintMini(5,1,"Score :",0);
    PrintV(35,1,coins);
}
void GUI::AddCoins(int v)
{
    coins += v;
}

class Control: public Script
{
    public:
    void Update();
    GUI * S_GUI;
};

void Control::Update()
{
    bool isground = GetObject()->GetRigibody()->CollisionDecor( GetX() , GetY()-1);
    bool isdo = false;

    if(input_press(K_RIGHT))
    {
        Move(2,0);
        SetIt(1);
        GetObject()->GetRender()->ReverseRender(false);
        isdo = true;
    }
    else if(input_press(K_LEFT))
    {
        Move(-2,0);
        SetIt(1);
        GetObject()->GetRender()->ReverseRender(true);
        isdo = true;
    }

    if(isground == true)
    {
        if(input_trigger(K_UP))
        {
            GetObject()->GetRigibody()->GetBody()->velocity.y = 80;
        }

        if(isdo == false)
        {
            SetIt(0);
        }
    }
    else
    {
        SetIt(2);
    }

    Object * Buffer = GetObject()->CollisionTagO("Coins");

    if(Buffer != NULL)
    {
        GetEngine()->DelObject(Buffer);
        S_GUI->AddCoins(1);
    }

    GetEngine()->MiddleScreen(GetX() + 8 , GetY() + 8);

}

int Jeu()
{
    //*************Sprites*************\\

    const unsigned char Perso_Normal[]={0xff, 0xff, 0xfc, 0x1f, 0xf0, 0x7, 0xe0, 0x7, 0xe0, 0x3, 0xc0, 0x53, 0x80, 0x51, 0x80, 0x51, 0x80, 0x1, 0x80, 0x1, 0xc8, 0x25, 0xf8, 0x7, 0xfc, 0xf, 0xe3, 0xf3, 0xc1, 0xe1, 0xff, 0xff, };
    const unsigned char Perso_NormalN[]={0x3, 0xe0, 0xf, 0xf8, 0x1f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfe, 0x7f, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0x3f, 0xfe, 0x1f, 0xfc, 0x3f, 0xfe, 0x7f, 0xff, 0x3e, 0x3e, };

    const unsigned char Perso_Marche_1[]={0xff, 0xff, 0xf8, 0x3f, 0xe0, 0xf, 0xe0, 0xf, 0xc0, 0x17, 0xc0, 0x17, 0xc2, 0x17, 0xc1, 0x7, 0xc1, 0x7, 0xe2, 0x17, 0xfc, 0x7, 0x90, 0xf, 0x88, 0x1f, 0x8f, 0xe3, 0xff, 0xc3, 0xff, 0xff, };
    const unsigned char Perso_Marche_1N[]={0x7, 0xc0, 0x1f, 0xf0, 0x3f, 0xf8, 0x3f, 0xf8, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0x7f, 0xfc, 0xff, 0xfc, 0xff, 0xf8, 0xff, 0xfc, 0xff, 0xfe, 0x70, 0x7e, 0x0, 0x3c, };
    const unsigned char Perso_Marche_2[]={0xff, 0xff, 0xf8, 0x1f, 0xe0, 0xf, 0xc0, 0xf, 0xc0, 0x57, 0x80, 0x57, 0x80, 0x55, 0x80, 0x5, 0x88, 0x5, 0xc8, 0x25, 0xf8, 0x7, 0xfc, 0xf, 0xf3, 0xff, 0xf8, 0x5f, 0xff, 0xff, 0xff, 0xff, };
    const unsigned char Perso_Marche_2N[]={0x7, 0xe0, 0x1f, 0xf0, 0x3f, 0xf8, 0x7f, 0xf8, 0x7f, 0xfc, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0x3f, 0xfe, 0x1f, 0xf8, 0x1f, 0xf0, 0xf, 0xf0, 0x7, 0xe0, 0x0, 0x0, };
    const unsigned char Perso_Marche_3[]={0xff, 0xff, 0xf8, 0x3f, 0xe0, 0xf, 0xf0, 0xf, 0x80, 0xa5, 0x80, 0xa5, 0x80, 0xa5, 0x80, 0x5, 0xe0, 0x7, 0xe0, 0x47, 0xe0, 0xb, 0xd0, 0xb, 0xcc, 0x33, 0xe3, 0xc7, 0xf1, 0xff, 0xff, 0xff, };
    const unsigned char Perso_Marche_3N[]={0x7, 0xc0, 0x1f, 0xf0, 0x3f, 0xf8, 0x7f, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xfe, 0x3f, 0xfc, 0x7f, 0xfe, 0x7f, 0xfe, 0x7f, 0xfe, 0x3f, 0xfc, 0x1f, 0x38, 0xe, 0x0, };

    const unsigned char Perso_Saut[]={0xff, 0xff, 0xfe, 0x1f, 0xc8, 0x5, 0x80, 0x5, 0x80, 0x1, 0x80, 0x3, 0xc0, 0x53, 0xe0, 0x53, 0xe0, 0x53, 0xe6, 0x3, 0xe9, 0x5, 0xf1, 0x29, 0xf0, 0x91, 0xf0, 0xa3, 0xf9, 0xe7, 0xff, 0xff, };
    const unsigned char Perso_SautN[]={0x1, 0xe0, 0x37, 0xfa, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x7f, 0xfe, 0x7f, 0xfe, 0x3f, 0xfe, 0x3f, 0xff, 0x3f, 0xff, 0x1f, 0xff, 0x1f, 0xff, 0x1f, 0xfe, 0xf, 0xfc, 0x7, 0x38, };

    Sprite S_Perso_Marche_1(Perso_Marche_1 , Perso_Marche_1N , 16 , 16);S_Perso_Marche_1.CreateReverse();
    Sprite S_Perso_Marche_2(Perso_Marche_2 , Perso_Marche_2N , 16 , 16);S_Perso_Marche_2.CreateReverse();
    Sprite S_Perso_Marche_3(Perso_Marche_3 , Perso_Marche_3N , 16 , 16);S_Perso_Marche_3.CreateReverse();

    Sprite S_Perso_Marche[]={ S_Perso_Marche_1 , S_Perso_Marche_2 , S_Perso_Marche_3};

    Sprite S_Perso_Normal(Perso_Normal , Perso_NormalN , 16 , 16);S_Perso_Normal.CreateReverse();

    Sprite S_Perso_Saut(Perso_Saut , Perso_SautN , 16 , 16);S_Perso_Saut.CreateReverse();

    Animation A_Perso_Normal( S_Perso_Normal);
    Animation A_Perso_Marche( S_Perso_Marche , 3 , 120 );
    Animation A_Perso_Saut( S_Perso_Saut );

    Animation A_Perso[]={ A_Perso_Normal , A_Perso_Marche , A_Perso_Saut};

    const unsigned char Po1[]={0x1e,0x0,0x21,0x0,0x40,0x80,0x8c,0x40,0x88,0x40,0x88,0x40,0x8c,0x40,0x40,0x80,0x21,0x0,0x1e,0x0};
    const unsigned char Po2[]={0x70,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x70};

    Sprite S_Coins1(Po1,10,10);
    Sprite S_Coins2(Po2,5,10,3,0);

    Sprite S_Coins[]={S_Coins1,S_Coins2};
    Animation A_Coins(S_Coins,2,150);

    const unsigned char SG1[]={0x7, 0xc1, 0x8, 0x21, 0x10, 0x11, 0x2c, 0x69, 0x42, 0x85, 0x47, 0xc5, 0x84, 0x43, 0x80, 0x3, 0x87, 0xc3, 0x78, 0x3d, 0x10, 0x21, 0x10, 0x19, 0x30, 0x7d, 0x3b, 0xfd, 0x1c, 0xf9, };
    const unsigned char SG2[]={0x7, 0xc1, 0x8, 0x21, 0x10, 0x11, 0x2c, 0x69, 0x42, 0x85, 0x47, 0xc5, 0x84, 0x43, 0x80, 0x3, 0x87, 0xc3, 0x78, 0x3d, 0x8, 0x11, 0x30, 0x11, 0x7c, 0x19, 0x7f, 0xb9, 0x3e, 0x71, };

    Sprite S_Goomba1(SG1,15,15);
    Sprite S_Goomba2(SG2,15,15);
    Sprite S_Goomba[]={S_Goomba1,S_Goomba2};

    Animation A_Goomba(S_Goomba,2,150);

    const unsigned char SKoopa1[]={0x0, 0x0, 0x18, 0x0, 0x24, 0x0, 0x24, 0x0, 0x46, 0x0, 0x65, 0x0, 0x64, 0x80, 0x64, 0x80, 0x48, 0x80, 0xb0, 0x80, 0x81, 0x38, 0x81, 0x44, 0x8a, 0xaa, 0x92, 0x92, 0x52, 0xa9, 0x25, 0x45, 0x25, 0x83, 0x35, 0x45, 0x15, 0x29, 0xd, 0x11, 0x4, 0xaa, 0x4, 0xfe, 0x6, 0x1, 0xb, 0x1, 0x10, 0xfe, 0x20, 0xa1, 0x3f, 0x1f, };
    const unsigned char SKoopa2[]={0x18, 0x0, 0x24, 0x0, 0x24, 0x0, 0x46, 0x0, 0x65, 0x0, 0x64, 0x80, 0x64, 0x80, 0x48, 0x80, 0xb0, 0x80, 0x81, 0x38, 0x99, 0x44, 0xaa, 0xaa, 0xca, 0x92, 0x12, 0xa9, 0x65, 0x45, 0x45, 0x83, 0x35, 0x45, 0x15, 0x29, 0xd, 0x11, 0x4, 0xaa, 0x4, 0xfe, 0x6, 0x1, 0x3, 0x1, 0x4, 0xfe, 0x4, 0x44, 0x3, 0x48, 0x0, 0xf0, };
    const unsigned char Shell[]={0x1c, 0x7f, 0x22, 0x7f, 0x55, 0x7f, 0x49, 0x7f, 0x54, 0xff, 0xa2, 0xff, 0xc1, 0xff, 0xa2, 0xff, 0x94, 0xff, 0x88, 0xff, 0x55, 0x7f, 0x7f, 0x7f, };

    Sprite S_Koopa1(SKoopa1,16,27);S_Koopa1.CreateReverse();
    Sprite S_Koopa2(SKoopa2,16,27);S_Koopa2.CreateReverse();
    Sprite S_Shell(Shell,9,12);

    Sprite S_Koopa[]={S_Koopa1,S_Koopa2};
    Animation A_KoopaN(S_Koopa,2,200);
    Animation A_Shell(S_Shell);
    Animation A_Koopa[]={A_KoopaN , A_Shell};

    //*************Object*************\\

    Object Perso;

    Perso.GetTransforms()->SetXY( 12 , 16 );
    Perso.GetRender()->SetRender( A_Perso , 3 );
    Perso.AffectTag("J1");

    Perso.AddRigibody();
    Perso.GetRigibody()->SetMass(5);

    Control * ScriptPerso = new Control;
    Perso.AffectScript(ScriptPerso);

    Object * Coins = new Object;
    Coins->GetTransforms()->SetXY(100,20);
    Coins->GetRender()->SetRender(A_Coins);
    Coins->AffectTag("Coins");

    Object * Goomba1 = new Object;
    Goomba1->GetTransforms()->SetXY(120,16);
    Goomba1->GetRender()->SetRender(A_Goomba);
    Goomba1->AddRigibody();
    Goomba1->GetRigibody()->SetMass(1);
    Goomba1->AffectTag("Goomba");

    IaGoomba * Script_Goomba1 = new IaGoomba;
    Goomba1->AffectScript(Script_Goomba1);

    Object * Koopa1 = new Object;
    Koopa1->GetTransforms()->SetXY(100,16);
    Koopa1->GetRender()->SetRender(A_Koopa,2);
    Koopa1->AddRigibody();
    Koopa1->GetRigibody()->SetMass(1);
    Koopa1->AffectTag("Koopa");

    IaKoopa * Script_Koopa1 = new IaKoopa;
    Koopa1->AffectScript(Script_Koopa1);

    //*************Map*************\\

    const unsigned char tileset[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0x0, 0x0, 0x0, 0x0, 0xaa, 0xaa, 0x55, 0x55, 0x0, 0x0, 0x0, 0x0, 0xaa, 0xaa, 0x55, 0x55, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0xff, 0xff, 0x80, 0x0, 0x80, 0x0, 0x8a, 0xaa, 0x95, 0x55, 0x90, 0x0, 0x90, 0x0, 0xba, 0xaa, 0xc5, 0x55, 0xc0, 0x0, 0xc0, 0x0, 0x80, 0x0, 0x80, 0x0, 0x80, 0x0, 0x80, 0x0, 0x80, 0x0, 0xff, 0xff, 0x0, 0x1, 0x0, 0x1, 0xaa, 0xa1, 0x55, 0x59, 0x0, 0x9, 0x0, 0x9, 0xaa, 0xad, 0x55, 0x53, 0x0, 0x3, 0x0, 0x3, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0xff, 0xff, 0x88, 0x1, 0x88, 0x1, 0x88, 0x1, 0x88, 0x1, 0xff, 0xff, 0x80, 0x21, 0x80, 0x21, 0x80, 0x21, 0x80, 0x21, 0xff, 0xff, 0x81, 0x1, 0x81, 0x1, 0x81, 0x1, 0x81, 0x1, 0xff, 0xff, 0xff, 0xff, 0x80, 0x1, 0x80, 0x1, 0x8f, 0xe1, 0x8f, 0xe1, 0x8c, 0x61, 0x8c, 0x61, 0x80, 0xe1, 0x80, 0xc1, 0x81, 0xc1, 0x81, 0xc1, 0x80, 0x1, 0x81, 0x81, 0x81, 0x81, 0x80, 0x1, 0xff, 0xff, };
    bool tileprop[]= { false , true , true, true , true,true};

  const unsigned char map[]={
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x04,0x00,0x00,0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x04,0x00,0x00,0x00,0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x02,0x01,0x01,0x01,0x01,0x01,
	0x02,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x03,0x00,0x00,0x00,0x00,0x00,0x02,0x01,0x01,0x01,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
};




    Map Niveau;
    Niveau.SetMap(tileset , map1 , tileprop , 16 , 16 , 50 ,10);

    //*************Moteur*************\\

    Engine Game;

    Game.AddObject( Coins);
    Game.AddObject( Goomba1);
    Game.AddObject( Koopa1);
    Game.AddObject( &Perso);

    Game.AffectMap( &Niveau);

    Game.SetType(1);
    Game.SetFpsWish(35);

    Niveau.AffectEngine( &Game);

    GUI * S_GUI = new GUI;
    Game.AffectScript(*S_GUI);

    ScriptPerso->S_GUI = S_GUI;

    Game.Game();

    return 1;
}

extern "C"
{
int AddIn_main(int isAppli, unsigned short OptionNum)
{
    Jeu();
    return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
}
